
without type_check

include truecolr.e
include image.e
include graphics.e

integer i,fr
sequence s,q,l
atom background,screen,sprite,t

i=init_VESA()
if i=ERROR_NO_VESA then
    puts(2,"VESA driver not found!\n")
    abort(1)
end if

l={}
for e=1 to 16 do
    l=append(l,rand({640,480})-{1,1})
end for

background=make_virtual_screen(640,480,{})
screen=make_virtual_screen(640,480,{})
s=read_bitmap("truecolr.bmp")
s=convert_bitmap(s)
sprite=bitmap2virtual(s)
q=rand({2,2,2})-1
for e=0 to 479 do
    s={}
    for f=128 to 1 by -1 do
        s=s&repeat({floor((q[1]*255-(e*255/479))*(f/128)),q[2]*floor((e*255/479)*(f/128)),q[3]*floor((255-(e*255/479))*(f/128))},5)
    end for
    virtual_pixel(background,{0,e},s)
end for

i=set_true_mode(TRUE_640X480)
if i then
    puts(2,"Error! I couldn't set the 640x480x16.8 million-color video mode!\n")
    abort(1)
end if

fr=0    t=time()
while get_key()=-1 do
    copy_image(background,screen,{{0,0},{639,479}},{0,0})
    fr=fr+1
    for e=1 to 16 do
        set_sprite(sprite,screen,l[e])
        l[e]=l[e]+rand({5,5})-rand({5,5})
        if l[e][1]<0 then l[e][1]=0 end if
        if l[e][2]<0 then l[e][2]=0 end if
    end for
    set_virtual_screen({0,0},{},screen)
end while

t=time()-t
if graphics_mode(-1) then end if

printf(1,"%d frames     %3.2f seconds   %2.2f frames/sec",{fr,t,fr/t})

